diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/genproc.p v15.6301-amd64/pop/src/syscomp/genproc.p
--- v15.63/pop/src/syscomp/genproc.p	1997-12-05 10:32:40.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/genproc.p	2010-01-03 07:29:42.000000000 -0500
@@ -59,9 +59,11 @@
 		M_MOVE
 		M_MOVEb
 		M_MOVEbit
+                M_MOVEi
 		M_MOVEs
 		M_MOVEsb
 		M_MOVEsbit
+                M_MOVEsi
 		M_MOVEss
 		M_MULT
 		M_NEG
@@ -83,6 +85,7 @@
 		M_UNWIND_SF
 		M_UPDb
 		M_UPDbit
+                M_UPDi
 		M_UPDs
 
 		/*	Registers */
@@ -129,18 +132,31 @@
 
 ;;; === REGISTER USAGE ================================================
 
+/*
+   rax - work                rcx - work
+   rdx - chain               rbx - pop user stack
+   rsp - stack               rbp - base
+   rsi - work                rdi - work
+   r8  - non pop lvar        r9  - helper for immediate constants
+   r10 - non pop lvar        r11 - non pop lvar
+   r12 - non pop lvar        r13 - pop lvar
+   r14 - pop lvar            r15 - pop lvar
+
+*/
+
 lconstant
 
 	;;; 80x86 register names and their usage
 
-	EAX = "eax",	;;; WK_REG/principal work reg/arg_reg_0
-	ECX = "ecx",	;;; secondary work reg/arg_reg_1
-	EDX = "edx",	;;; CHAIN_REG/arg_reg_2
-	EBX = "ebx",	;;; USP
-	ESP = "esp",	;;; SP
-	EBP = "ebp",	;;; PB (procedure base reg)
-	ESI = "esi",	;;; WK_ADDR_REG_1
-	EDI = "edi",	;;; WK_ADDR_REG_2
+	EAX = "rax",	;;; WK_REG/principal work reg/arg_reg_0
+	ECX = "rcx",	;;; secondary work reg/arg_reg_1
+	EDX = "rdx",	;;; CHAIN_REG/arg_reg_2
+	EBX = "rbx",	;;; USP
+	ESP = "rsp",	;;; SP
+	EBP = "rbp",	;;; PB (procedure base reg)
+	ESI = "rsi",	;;; WK_ADDR_REG_1
+	EDI = "rdi",	;;; WK_ADDR_REG_2
+        R9  = "r9",
 ;
 
 constant
@@ -190,8 +206,18 @@
 	;;;	Lists of pop/non-pop registers for register locals
 	;;; (none on this machine)
 
-	pop_registers = [[]],
-	nonpop_registers = [[]],
+/*
+        pop_registers = [[] 13 14 15],
+	nonpop_registers = [[] 8 10 11 12],
+
+        pop_registers = [[]],
+
+        nonpop_registers = [[]],
+*/
+        pop_registers = [[]],
+        nonpop_registers = [[] 8 10 11 12],
+/*       nonpop_registers = [[] 8 12], */
+
 ;
 
 ;;; regnumber:
@@ -227,6 +253,39 @@
 	])
 enddefine;
 
+define int_reglabel = newassoc([]); enddefine;
+
+define word_reglabel = newassoc([]); enddefine;
+
+define byte_reglabel = newassoc([]); enddefine;
+
+procedure();
+        lvars n, l, li, lw, lb;
+        for n from 0 to 7 do
+            reglabel(n) -> l;
+            consword(`e`, l(2), l(3), 3) -> li;
+            allbutfirst(1, l) -> lw;
+            if n < 4 then
+                consword(lw(1), `l`, 2)
+            else
+                consword(lw(1), lw(2), `l`, 3)
+            endif -> lb;
+            li ->  int_reglabel(n);
+            lw -> word_reglabel(n);
+            lb -> byte_reglabel(n);
+        endfor;
+        for n from 8 to 15 do
+                consword('r' >< n) -> l;
+                consword('r' >< n >< 'd') -> li;
+                consword('r' >< n >< 'w') -> lw;
+                consword('r' >< n >< 'b') -> lb;
+                n -> regnumber(l);
+                l -> reglabel(n);
+                li -> int_reglabel(n);
+                lw -> word_reglabel(n);
+                lb -> byte_reglabel(n);
+        endfor
+endprocedure();
 
 ;;; Local register operands:
 
@@ -377,39 +436,38 @@
 		mishap(opcode, 1, 'WORD NEEDED');
 	endunless;
 	pop11_need_nextreaditem(")") -> ;
-#_IF DEF MASM
-	;;; map from Unix --> Intel opcodes
-	define lconstant to_intel =
+	;;; map to amd64 opcodes
+	define lconstant to_amd64 =
 		newproperty([
-			[incl		inc]
-			[decl		dec]
-			[addl		add]
-			[sall		sal]
-			[sarl		sar]
-			[testl		test]
-			[cmpl		cmp]
-			[xorl		xor]
-			[movl		mov]
-			[imull		imul]
-			[movb       mov]
-			[movw       mov]
-			[movzbl     movzx]
-			[movzwl     movzx]
-			[movsbl     movsx]
-			[movswl     movsx]
-			[pushl		push]
-			[popl		pop]
-			[leal		lea]
-			[addl		add]
-			[subl		sub]
-			[negl		neg]
-			[andl		and]
-			[orl		or]
-			[notl		not]
+			[incl		incq]
+			[decl		decq]
+			[addl		addq]
+			[sall		salq]
+			[sarl		sarq]
+			[testl		testq]
+			[cmpl		cmpq]
+			[xorl		xorq]
+			[movl		movq]
+			[imull		imulq]
+			[movb       movb]
+			[movw       movw]
+                        [movd       movl]
+			[movzbl     movzbq]
+			[movzwl     movzwq]
+			[movsbl     movsbq]
+			[movswl     movswq]
+			[pushl		pushq]
+			[popl		popq]
+			[leal		leaq]
+			[addl		addq]
+			[subl		subq]
+			[negl		negq]
+			[andl		andq]
+			[orl		orq]
+			[notl		notq]
 		], 32, false, "perm");
 	enddefine;
-	to_intel(opcode) or opcode -> opcode;
-#_ENDIF
+	to_amd64(opcode) or opcode -> opcode;
 	""", opcode, """;
 enddefine;
 
@@ -587,7 +645,7 @@
 
 define lconstant long_opd(opd) -> opd;
 	lvars opd;
-	adjust(opd, WORD_OFFS) -> opd;
+	adjust(opd, DOUBLE_OFFS) -> opd;
 #_IF DEF MASM
 	if ismem(opd) then
 		consTypedOperand("dword", opd) -> opd;
@@ -595,12 +653,28 @@
 #_ENDIF
 enddefine;
 
+define lconstant int_opd(opd) -> opd;
+        lvars opd;
+        adjust(opd, INT_OFFS) -> opd;
+        if isreg(opd) then
+                ;;; replace with 32-bit register name
+                int_reglabel(regnumber(opd)) -> opd;
+                ;;; consword(`e`, opd(2), opd(3), 3) -> opd;
+#_IF DEF MASM
+        elseif ismem(opd) then
+                consTypedOperand("dword", opd) -> opd;
+#_ENDIF
+        endif;
+enddefine;
+
+
 define lconstant word_opd(opd) -> opd;
 	lvars opd;
 	adjust(opd, SHORT_OFFS) -> opd;
 	if isreg(opd) then
 		;;; replace with 16-bit register name
-		allbutfirst(1, opd) -> opd;
+		;;; allbutfirst(1, opd) -> opd;
+                word_reglabel(regnumber(opd)) -> opd;
 #_IF DEF MASM
 	elseif ismem(opd) then
 		consTypedOperand("word", opd) -> opd;
@@ -613,10 +687,13 @@
 	adjust(opd, BYTE_OFFS) -> opd;
 	if isreg(opd) then
 		;;; replace with 8-bit register name (if allowed)
+/*
 		unless regnumber(opd) < 4 then
 			mishap(opd, 1, 'ILLEGAL 8-BIT REGISTER NAME');
 		endunless;
 		consword(opd(2), `l`, 2) -> opd;
+*/
+                byte_reglabel(regnumber(opd)) -> opd;
 #_IF DEF MASM
 	elseif ismem(opd) then
 		consTypedOperand("byte", opd) -> opd;
@@ -719,6 +796,13 @@
 	endif;
 enddefine;
 
+define lconstant asmMOVD(src, dst);
+        lvars src, dst;
+        int_opd(src) -> src;
+        int_opd(dst) -> dst;
+        asm_emit(OPCODE(movd), OPERANDS(src, dst), 3);
+enddefine;
+
 define lconstant asmMOVW(src, dst);
 	lvars src, dst;
 	word_opd(src) -> src;
@@ -733,6 +817,21 @@
 	asm_emit(OPCODE(movb), OPERANDS(src, dst), 3);
 enddefine;
 
+/* Valid only if dst is a register */
+define lconstant asmMOVZDL(src, dst);
+        lvars src, dst;
+        int_opd(src) -> src;
+        int_opd(dst) -> dst;
+        asm_emit(OPCODE(movd), OPERANDS(src, dst), 3);
+enddefine;
+
+define lconstant asmMOVSDL(src, dst);
+        lvars src, dst;
+        int_opd(src) -> src;
+        long_opd(dst) -> dst;
+        asm_emit(OPCODE(movslq), OPERANDS(src, dst), 3);
+enddefine;
+
 define lconstant asmMOVZWL(src, dst);
 	lvars src, dst;
 	word_opd(src) -> src;
@@ -901,6 +1000,18 @@
 	]);
 enddefine;
 
+define constant is_large_int(src);
+  lvars src;
+  if isinteger(src) or isbiginteger(src) then
+    if (src < -2147483648) or (src > 2147483647) then
+      true
+    else
+      false
+    endif
+  else
+    false
+  endif
+enddefine;
 
 /*
  *	Data Movement
@@ -912,6 +1023,9 @@
 		if ismem(src) and ismem(dst) then
 			asmMOVL(src, EAX ->> src);
 		endif;
+                if is_large_int(src) then
+                  asmMOVL(src, EAX ->> src);
+                endif;
 		asmMOVL(src, dst);
 	endunless;
 enddefine;
@@ -940,7 +1054,7 @@
 define lconstant gen_move_from_l(asm_op);
 	lvars asm_op, (, src, dst) = explode(m_instr);
 	if ismem(src)
-	or isreg(src) and asm_op == asmMOVB and regnumber(src) fi_>= 4
+	;;; or isreg(src) and asm_op == asmMOVB and regnumber(src) fi_>= 4
 	then
 		asmMOVL(src, EAX ->> src);
 	endif;
@@ -951,8 +1065,11 @@
 define M_MOVEsb	= gen_move_to_l(% asmMOVSBL %) enddefine;
 define M_MOVEs	= gen_move_to_l(% asmMOVZWL %) enddefine;
 define M_MOVEss	= gen_move_to_l(% asmMOVSWL %) enddefine;
+define M_MOVEi  = gen_move_to_l(% asmMOVZDL %) enddefine;
+define M_MOVEsi = gen_move_to_l(% asmMOVSDL %) enddefine;
 define M_UPDb	= gen_move_from_l(% asmMOVB %) enddefine;
 define M_UPDs	= gen_move_from_l(% asmMOVW %) enddefine;
+define M_UPDi   = gen_move_from_l(% asmMOVD %) enddefine;
 
 ;;; gen_bfield:
 ;;;		extract a bitfield from a structure using assembly code routines
@@ -1011,7 +1128,11 @@
 	lvars src1, src2, dst;
 	if isreg(src1) then
 		if isreg(src2) then	;;; base + index
+                    if src2 /== ESP then
 			{^src1 0 ^src2};
+                    else
+                        {^src2 0 ^src1};
+                    endif
 		else						;;; base + displacement
 			{% src1, asm_uselab(immval(src2)) %};
 		endif;
@@ -1071,11 +1192,31 @@
 		if ismem(src1) and ismem(dst) then
 			asmMOVL(src1, EAX ->> src1);
 		endif;
+                if is_large_int(src1) then
+                  asmMOVL(src1, altwkreg(src2) ->> src1);
+                endif;
 		asm_op(src1, dst);
 	else
+            if is_large_int(src1) and is_large_int(src2) then
+                   if isreg(dst) then
+                     altwkreg(dst) -> tmp;
+                     asmMOVL(src1, dst);
+                     asmMOVL(src2, tmp);
+                     asm_op(tmp, dst);
+                   else
+                     asmMOVL(src1, EAX);
+                     asmMOVL(src2, ECX);
+                     asm_op(ECX, EAX);
+                     asmMOVL(EAX, dst);
+                   endif;
+            else
 		/* {____src1 __/= ___dst _& ____src2 __/= ___dst} */
 		if ismem(src1) then (src1, src2) -> (src2, src1) endif;
 		/* {__________~mem(src1) _| _________mem(src2)} */
+                if is_large_int(src1) then (src1, src2) -> (src2, src1) endif;
+
+#_IF false
+                   
 		if isreg(dst) and dst /== reg_in_operand(src1) then
 			dst -> tmp;
 		elseif wkreg(src2) then
@@ -1086,11 +1227,18 @@
 		else
 			altwkreg(src1) -> tmp;
 		endif;
+#_ELSE
+                R9 -> tmp;
+#_ENDIF
 		if asm_op == asmADDL and not(set_flags)
-		and not(ismem(src1)) and not(ismem(src2))
+		and not(ismem(src1)) and not(ismem(src2)) 
+                and not(is_large_int(src2))
 		then
 			/* {__________~mem(src1) _& __________~mem(src2) _& ________reg(tmp)} */
 			/* optimise move+add to lea */
+/*
+                        if src2 == ESP then (src1, src2) -> (src2, src1) endif;
+*/
 			gen_lea(src1, src2, tmp);
 			asmMOVL(tmp, dst);
 		else
@@ -1100,6 +1248,7 @@
 			asmMOVL(tmp, dst);
 		endif;
 	endif;
+    endif;
 enddefine;
 
 define lconstant gen_add = gen_op_2(% asmADDL %) enddefine;
@@ -1112,39 +1261,71 @@
 ;;;		When _________set_flags is true, the code planted must leave the flags set
 ;;;		correctly for a subsequent test.
 
+;;; global constant _print_addr;
 define lconstant gen_sub(src1, src2, dst);
 	lvars src1, src2, dst, tmp;
+;;;        printf(src1, 'src1 = %p, ');
+;;;        printf(src2, 'src2 = %p, ');
+;;;        printf(dst, 'dst = %p\n');
+;;;           printf('Moja pulapka\n');
+;;;        _print_addr(dst) -> _;
 	if src2 = dst then
-		if ismem(src1) and ismem(dst) then
+;;;                printf('src2 = dst\n');
+		if ismem(src1) and ismem(dst) or 
+                    is_large_int(src1) then
+;;;                        printf('asmMOVL(src1, EAX ->> src1);\n');
 			asmMOVL(src1, EAX ->> src1);
 		endif;
+;;;                printf('asmSUBL(src1, dst);\n');
 		asmSUBL(src1, dst);
 	elseif isreg(dst) and src1 == dst then
+;;;                printf('isreg(dst) and src1 == dst\n');
+                if is_large_int(src2) then
+;;;                    printf('asmMOVL(src2, R9 ->> src2);\n');
+                    asmMOVL(src2, R9 ->> src2);
+                endif;
+;;;                printf('asmSUBL(src2, dst);\n');
 		asmSUBL(src2, dst);
+;;;                printf('asmNEGL(dst);\n');
 		asmNEGL(dst);
 	else
+;;;                printf('else\n');
 		if isreg(dst) and dst /== reg_in_operand(src1) then
+;;;                        printf('isreg(dst) and dst /== reg_in_operand(src1)\n');
 			dst -> tmp;
 		elseif wkreg(src2) then
+;;;                        printf('wkreg(src2)\n');
 			src2 -> tmp;
 		else
+;;;                        printf('else: altwkreg(src1) -> tmp;\n');
 			altwkreg(src1) -> tmp;
 		endif;
-		if not(set_flags) and isintegral(src1) and not(ismem(src2)) then
+                if is_large_int(src1) then 
+;;;                   printf('asmMOVL(src1, R9 ->> src1);');
+                   asmMOVL(src1, R9 ->> src1);
+                endif;
+		if not(set_flags) and isintegral(src1) and
+                   not(is_large_int(src2)) and not(ismem(src2)) then
 			/* {________________isintegral(src1) _& __________~mem(src2) _& ________reg(tmp)} */
 			;;; negate src1 and optimise to lea
+;;;                        printf('gen_lea(src2, -src1, tmp);\n');
 			gen_lea(src2, -src1, tmp);
 		else
 			/* {____src2 _= ___tmp _| ___tmp __/= ____________________reg_in_operand(src1)} */
+;;;                        printf('asmMOVL(src2, tmp);\n');
 			asmMOVL(src2, tmp);
+;;;                        printf('asmSUBL(src1, tmp);\n');
 			asmSUBL(src1, tmp);
 			if src1 == USP_+ and src2 == USP_+ then
 				;;; the subtraction operation will have gone the wrong way
+;;;                                printf('asmNEGL(tmp);\n');
 				asmNEGL(tmp);
 			endif;
 		endif;
+;;;                printf('asmMOVL(tmp, dst);\n');
 		asmMOVL(tmp, dst);
 	endif;
+;;;        printf('end of gen_sub\n');
 enddefine;
 
 ;;;	gen_mult:
@@ -1345,9 +1526,34 @@
 
 define lconstant gen_test_or_cmp(src1, src2, test, lab, gen_p);
 	lvars src1, src2, test, lab, gen_p;
+;;;        printf(src1, src2, 'gen_test_or_cmp:\n %p\n %p\n');
+        if isimm(src1) and isimm(src2) then
+           if isinteger(src2) or isbiginteger(src2) then
+              if (src2 < -2147483648) or (src2 > 2147483647) then
+                asmMOVL(src2, EAX ->> src2);
+              else
+                asmMOVL(src1, EAX ->> src1);
+              endif;
+           else
+             asmMOVL(src1, EAX ->> src1);
+           endif;
+        endif;
+        if isinteger(src1) or isbiginteger(src1) then
+           if (src1 < -2147483648) or (src1 > 2147483647) then
+;;;              printf('loading big constant to register\n');
+              asmMOVL(src1, altwkreg(src2) ->> src1);
+           endif;
+        endif;
+        if isinteger(src2) or isbiginteger(src2) then
+          if src2 < -2147483648 or src2 > 2147483647 then
+;;;             printf('loading big constant to register\n');
+             asmMOVL(src2, altwkreg(src1) ->> src2);
+          endif;
+        endif;
 	if ismem(src1) and ismem(src2) or isimm(src1) and isimm(src2) then
 		asmMOVL(src1, altwkreg(src2) ->> src1);
 	endif;
+        
 	if isimm(src1) or ismem(src2) then
 		;;; ____src1 can't be an immediate operand;
 		;;; also, if there's a memory operand in the test it's better
@@ -1457,9 +1663,11 @@
 	;;; or if it's a POP integer we want (table_start + src - 3)
 	lvars target;
 	if sysint then
-		{% false, table_start, src, 4 %}
+		{% false, table_start, src, 8 %}
 	else
-		{% src, asm_expr(table_start, "-", 3) %}
+;;;		{% src, asm_expr(table_start, "-", 3) %}
+;;;             printf('gen_switch on pop integer');
+		{% false, asm_expr(table_start, "-", 6), src, 2 %}
 	endif -> target;
 	asmJMP(conspair(target, 0));
 	;;; Plant the table; it begins with -else_lab- to account for the 0 case
@@ -1493,11 +1701,11 @@
 ;;; M_BRANCH_std:
 ;;;     same as M_BRANCH, but guarantees to produce an instruction of a
 ;;;     fixed size. That's not directly available from 386 assembler, so
-;;;     we simulate it by moving the label to a register (= 5 bytes) and
+;;;     we simulate it by moving the label to a register (= 7 bytes) and
 ;;;		then jumping off that
 
 define M_BRANCH_std();
-	asmMOVL(immrep(m_instr(2)), EAX);		;;; movl $L, %eax (5 bytes)
+	asmMOVL(immrep(m_instr(2)), EAX);		;;; movl $L, %eax (7 bytes)
 	asmJMP(conspair(EAX, 0));			;;; jmp	*%eax     (2 bytes)
 enddefine;
 
@@ -1592,7 +1800,9 @@
 
 	dlocal_labs,
 		;;; Names of dynamic local variables
+        regmask,
 	Nstkvars,
+        Nregs,
 		;;; Number of on-stack vars
 ;
 
@@ -1602,17 +1812,32 @@
 
 define M_CREATE_SF();
 	lconstant popint_zero = popint(0);
-	lvars reg_spec_id, Npopstkvars, reg_locals;
+	lvars reg_spec_id, Npopregs, Npopstkvars, reg_locals, n;
 
 	explode(m_instr) -> reg_spec_id -> dlocal_labs -> Npopstkvars
-		-> Nstkvars -> /* Npopregs */ -> reg_locals -> ;
+		-> Nstkvars -> Npopregs -> reg_locals -> ;
 
+/*
 	;;; Check there are no register locals and set the register spec to zero
 	unless null(reg_locals) then
 		mishap(reg_locals, 1, 'UNEXPECTED REGISTER LOCALS');
 	endunless;
+*/
 	0 -> idval(reg_spec_id);
 
+        listlength(reg_locals) -> Nregs;
+
+        ;;; create register mask from reg locals
+        0 -> regmask;
+        fast_for n in reg_locals do regmask || (1 << n) -> regmask endfast_for;
+
+        ;;; Save registers
+        for n from 8 to 15 do
+            if regmask &&/=_0 (1 << n) then
+                asmPUSHL(reglabel(n));
+            endif;
+        endfor;
+
 	;;; Set the procedure base register
 	asmMOVL(immrep(current_pdr_label), PB);
 	;;; Push dynamic locals
@@ -1621,7 +1846,7 @@
 	repeat Npopstkvars times asmPUSHL(popint_zero) endrepeat;
 	;;; Allocate non-POP on-stack lvars (uninitialised)
 	if Nstkvars /== Npopstkvars then
-		asmSUBL((Nstkvars - Npopstkvars) * 4, SP);
+		asmSUBL((Nstkvars - Npopstkvars) * 8, SP);
 	endif;
 	;;; Push the owner address
 	asmPUSHL(PB);
@@ -1631,12 +1856,21 @@
 ;;;		plant code to unwind a procedure stack frame
 
 define M_UNWIND_SF();
+        lvars n;
 	;;; Remove owner address and on-stack vars (POP and non-POP)
-	asmADDL((Nstkvars + 1) * 4, SP);
+	asmADDL((Nstkvars + 1) * 8, SP);
 	;;; Pop dynamic locals
 	applist(rev(dlocal_labs), asmPOPL);
+        ;;; restore registers
+
+        for n from 15 by -1 to 8 do
+            if regmask &&/=_0 (1 << n) then
+                asmPOPL(reglabel(n));
+            endif;
+        endfor;
+
 	;;; Restore procedure base register from previous owner address
-	asmMOVL({^SP 4}, PB);
+	asmMOVL({^SP 8}, PB);
 enddefine;
 
 endlblock;
@@ -1666,10 +1900,10 @@
 		;;; get closure address in EAX
 		asmMOVL(immrep(current_pdr_label), EAX);
 		;;; push the frozvals
-		lconstant frozval_offset = field_##("PD_CLOS_FROZVALS").wof - 4;
+		lconstant frozval_offset = field_##("PD_CLOS_FROZVALS").wof - 8;
 		lvars i;
 		for i to nfroz do
-			asmMOVL({% EAX, frozval_offset + i*4 %}, ECX);
+			asmMOVL({% EAX, frozval_offset + i*8 %}, ECX);
 			asmMOVL(ECX, -_USP);
 		endfor;
 		unless pdpart_opd then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/m_optimise.p v15.6301-amd64/pop/src/syscomp/m_optimise.p
--- v15.63/pop/src/syscomp/m_optimise.p	1998-04-29 11:12:54.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/m_optimise.p	2005-03-11 05:30:40.000000000 -0500
@@ -232,8 +232,12 @@
 					[^T_SGN_BYTE	{^M_MOVEsb	  ^M_UPDb} ]
 					[^T_SHORT		{^M_MOVEs	  ^M_UPDs} ]
 					[^T_SGN_SHORT	{^M_MOVEss	  ^M_UPDs} ]
+                                        [^T_INT                 {^M_MOVEi  ^M_UPDi}]
+                                        [^T_SGN_INT             {^M_MOVEsi  ^M_UPDi}]
 					[^T_WORD		{^M_MOVE	  ^M_MOVE} ]
+                                        [^T_INT_DOUBLE          {^M_MOVE          ^M_MOVE} ]
 					]);
+;;;        printf(acctype, 'typed_move_instr: acctype = %p\n');
 	type_m_opcode(acctype) -> op;
 	if upd then f_subv(2,op) else f_subv(1,op) endif -> op;
 #_ENDIF
@@ -270,6 +274,7 @@
 
 	f_hd(m_codelist) -> inst;
 	f_subv(1, inst) -> opcode;
+;;;        printf(opcode, inst, 'get_moves if: \n inst = %p\n opcode = %p\n');
 	if isstring(pdprops(opcode) ->> x) and f_subs(1, x) == `%` then
 		;;; pseudo-op
 		opcode(m_codelist, mustconvert) -> m_codelist;
@@ -279,6 +284,7 @@
 		returnif(opcode == x);		;;; didn't convert
 		true -> got_one
 	endif;
+;;;        printf('get_moves endif\n');
 
 	if (arithop1(opcode) ->> l) and isintegral(inst(2)) then
 		l(inst(2)) -> y, inst(3) -> z
@@ -471,8 +477,11 @@
 	lvars mustconvert, push_precedes;
 	dlocal m_codelist;
 	repeat
+;;;                printf('premove\n');
 		premove(m_codelist, push_precedes);
+;;;                printf('postmove\n');
 		postmove(m_codelist, false);
+;;;                printf('get_moves\n');
 		quitunless(get_moves(m_codelist, mustconvert) -> m_codelist)
 	endrepeat;
 	if mustconvert then postmove(m_codelist, true) endif
@@ -570,6 +579,7 @@
 	lvars i;
 	m_codelist -> org_m_codelist;
 	until m_codelist == [] do
+;;;                printf(hd(m_codelist), 'm_optimise: %p\n');
 		if f_subv(1, f_hd(m_codelist)) /== M_LABEL then
 			do_premove(m_codelist, true, false) -> m_codelist;
 			if finalimprove(f_hd(m_codelist)) ->> i then
@@ -680,6 +690,7 @@
 		%] . replace_current
 	else
 		;;; non bitfield
+;;;                printf('OP_!\n');
 		get_access_type(type_code) -> acctype;
 		if offs_index /== 0 then
 			if indexscale /== 1 then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/m_trans.p v15.6301-amd64/pop/src/syscomp/m_trans.p
--- v15.63/pop/src/syscomp/m_trans.p	1998-03-25 09:22:57.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/m_trans.p	2009-12-24 15:33:20.000000000 -0500
@@ -2094,7 +2094,7 @@
 	endunless;
 #_ENDIF
 
-	if pd_frame_len > 16:FF then
+	if pd_frame_len > MAX_STACK_FRAME_SIZE then
 		mishap(p, 1, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars)')
 	endif;
 
@@ -2181,8 +2181,19 @@
 				2);
 
 	asm_outshort(reg_spec, 1);				;;; PD_REGMASK
-
-	asm_outbyte(
+#_IF DEF FRAME_LEN_16BIT
+        asm_outshort(0, 1);
+        asm_outshort
+#_ELSE
+#_IF DEF FRAME_LEN_32BIT
+        asm_outshort(0, 1);
+        asm_outint(0, 1);
+        asm_outint
+#_ELSE
+        asm_outbyte
+#_ENDIF
+#_ENDIF
+	(
 			;;; stack frame length in words
 			pd_frame_len,					;;; PD_FRAME_LEN
 			;;; see above
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/mcdata.p v15.6301-amd64/pop/src/syscomp/mcdata.p
--- v15.63/pop/src/syscomp/mcdata.p	1995-08-24 13:17:32.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/mcdata.p	2009-12-24 15:32:59.000000000 -0500
@@ -107,6 +107,15 @@
 endsection;		/* $- */
 
 
+constant macro MAX_STACK_FRAME_SIZE =
+  #_IF DEF FRAME_LEN_16BIT 
+          16:FFFF
+  #_ELSEIF DEF FRAME_LEN_32BIT
+          16:FFFFFFFF
+  #_ELSE
+          16:FF
+  #_ENDIF;
+
 section $-Popas;
 
 constant macro (
Only in v15.6301-amd64/pop/src/syscomp: new
